using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace SoftwareInstallerClient
{
    public partial class MainForm : Form
    {

        private SoftwareInstallerClientService client;

        public MainForm()
        {
            InitializeComponent();

            client = new SoftwareInstallerClientService();
            client.UpdateNeededProgram += new UpdateNeededProgramEventHandler(client_UpdateNeededProgram);
            this.client.Start();
        }

        void client_UpdateNeededProgram(List<SoftwareInstallerLibrary.SoftwareData> softs)
        {
            if (this.listBoxProgramNeeded.InvokeRequired)
                this.listBoxProgramNeeded.Invoke(new UpdateNeededProgramEventHandler(this.client_UpdateNeededProgram), softs);
            else
            {
                this.listBoxProgramNeeded.Items.Clear();
                this.listBoxProgramNeeded.Items.AddRange(softs.ToArray());
            }
        }

        private void MainForm_FormClosed(object sender, FormClosedEventArgs e)
        {
            this.client.Stop();
        }

        private void buttonQuit_Click(object sender, EventArgs e)
        {
            this.Close();
        }
    }
}