using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Text;
using System.ServiceModel;
using SoftwareInstallerLibrary;
using System.Timers;
using System.Windows.Forms;

namespace SoftwareInstallerClient
{

    public delegate void UpdateNeededProgramEventHandler(List<SoftwareData> softs);

    /// <summary>
    /// Service client rcuprant la liste des softs  installer sur le client
    /// </summary>
    public partial class SoftwareInstallerClientService 
    {

        private ChannelFactory<IRemoteService> channelFactory;
        private IRemoteService remoteSerice;
        private System.Timers.Timer timer;
        private ClientInformation clientInformation;

        public event UpdateNeededProgramEventHandler UpdateNeededProgram;

        public SoftwareInstallerClientService()
        {
            
        }

        public void Start()
        {
            channelFactory = new ChannelFactory<IRemoteService>("SI");
            channelFactory.Open();

            remoteSerice = channelFactory.CreateChannel();

            clientInformation = new ClientInformation();
            clientInformation.ClientVersion = new Version("1.0.0.0");
            clientInformation.Name = "dev01";
            clientInformation.UserName = Environment.UserName;

            //Envoi de l'authentification au serveur
            remoteSerice.IdentifyClient(clientInformation);

            //Timer toute les 5 minutes
            timer = new System.Timers.Timer(6000);
            timer.Elapsed += new ElapsedEventHandler(timer_Elapsed);
            timer.Enabled = true;
            
        }

        void timer_Elapsed(object sender, ElapsedEventArgs e)
        {
            List<SoftwareData> softs = remoteSerice.GetSoftwareList(clientInformation);

            if (this.UpdateNeededProgram != null)
                this.UpdateNeededProgram(softs);
        }

        public void Stop()
        {
            timer.Enabled = false;

            channelFactory.Close();
        }
    }
}
