using System;
using System.Collections.Generic;
using System.Text;
using System.ServiceModel;

namespace SoftwareInstallerLibrary
{

    /// <summary>
    /// Interface de dfinition du service distant
    /// </summary>
    [ServiceContract]
    public interface IRemoteService
    {

        /// <summary>
        /// Identifie le client sur le serveur.
        /// </summary>
        /// <param name="clientInformation">Les informations d'identification du client</param>
        [OperationContract]
        void IdentifyClient(ClientInformation clientInformation);

        /// <summary>
        /// Obtient la liste des logiciels  installer sur le client
        /// </summary>
        /// <returns></returns>
        [OperationContract]
        List<SoftwareData> GetSoftwareList(ClientInformation clientInformation);

        /// <summary>
        /// Renvois le rapport d'installation au serveur afin de centraliser l'information
        /// </summary>
        /// <param name="clientReport">le rapport du client sur l'installation des logiciels</param>
        [OperationContract]
        void UploadReport(ClientReport clientReport);

    }
}
