using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.Serialization;

namespace SoftwareInstallerLibrary
{

    /// <summary>
    /// Classe reprsentant un logiciel devant tre install sur le poste client
    /// </summary>
    [DataContract]
    public class SoftwareData
    {

        private string name;
        private string installerAddress;
        private Version version;

        /// <summary>
        /// Constructeur par dfaut
        /// </summary>
        public SoftwareData()
        {

        }

        #region Proprietes

        /// <summary>
        /// Obtient ou dfini le nom du logiciel  installer
        /// </summary>
        [DataMember]
        public string Name
        {
            get
            {
                return this.name;
            }

            set
            {
                this.name = value;
            }
        }

        /// <summary>
        /// Obtient ou dfini l'adresse de l'installeur
        /// </summary>
        [DataMember]
        public string InstallerAddress
        {
            get
            {
                return this.installerAddress;
            }

            set
            {
                this.installerAddress = value;
            }
        }

        /// <summary>
        /// Obtient ou dfini la version du logiciel  installer
        /// </summary>
        [DataMember]
        public Version Version
        {
            get
            {
                return this.version;
            }

            set
            {
                this.version = value;
            }
        }

        #endregion

        public override string ToString()
        {
            return this.name + " " + this.version.ToString();
        }

    }
}
