using System;
using System.Collections.Generic;
using System.Text;
using SoftwareInstallerLibrary;
using System.ServiceModel;

namespace SoftwareInstallerServerService
{

    /// <summary>
    /// Implmentation de l'interface du service WCF
    /// </summary>
    [ServiceBehavior(InstanceContextMode = InstanceContextMode.Single, ConcurrencyMode = ConcurrencyMode.Single)]
    public class RemoteService : IRemoteService
    {

        private Dictionary<string, ClientInformation> clientInformations;
        private List<string> clientAuthentified;

        /// <summary>
        /// Constructeur par dfaut
        /// </summary>
        public RemoteService()
        {
            this.clientInformations = new Dictionary<string, ClientInformation>();
            this.clientAuthentified = new List<string>();

            //DEBUG
            ClientInformation ci = new ClientInformation();
            ci.ClientVersion = new Version("1.0.0.0");
            ci.Name = "dev01";

            this.clientInformations.Add(ci.Name, ci);
        }

        #region IRemoteService Members

        public void IdentifyClient(ClientInformation clientInformation)
        {
            if ( !clientInformations.ContainsKey(clientInformation.Name))
            {
                throw new Exception("Client inconnu !");
            }

            if (clientAuthentified.Contains(clientInformation.Name))
                throw new Exception("Client dj authentifi");

            this.clientAuthentified.Add(clientInformation.Name);
        }

        public List<SoftwareData> GetSoftwareList(ClientInformation clientInformation)
        {
            if (this.clientAuthentified.Contains(clientInformation.Name))
            {
                //DEBUG
                SoftwareData soft = new SoftwareData();
                soft.InstallerAddress = @"\\myserver\partage\setup.exe";
                soft.Name = "Test";
                soft.Version = new Version("0.0.0.1");

                List<SoftwareData> lists = new List<SoftwareData>();
                lists.Add(soft);

                return lists;
            }
            else
            {
                throw new Exception("Client non authentifi");
            }
        }

        public void UploadReport(ClientReport clientReport)
        {
            
        }

        #endregion
    }
}
